package pen_flowchart;

import java.awt.event.ActionEvent;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class Parts_LoopBeginDec extends Parts_LoopBegin {
	String var, start, end, step;
	String text2;

	public Parts_LoopBeginDec()
	{
		super();
		setValue("≪変数≫","≪値≫","≪値≫","≪値≫");
	}

	@Override
	public boolean hasText()
	{
		return true;
	}

	public void setValue(String s1, String s2, String s3, String s4)
	{
		var = new String(s1);
		start = new String(s2);
		end = new String(s3);
		step = new String(s4);
		setText(var+":"+start+"→"+end);
		setText2(step+"ずつ減");
	}

	@Override
	public Parts appendTo(StringBuilder sb, int indentLevel) {
		Parts pNext = this;
		makeIndent(sb, indentLevel);
		sb.append(var+" を " + start + " から " + end + " まで "+step+" ずつ減らしながら，\n");
		if(getLeft() != null)
		{
			pNext = getLeft().appendTo(sb, indentLevel + 1);
			if(getLeft().getLeft().isRecursiveEnd())
			{
				makeIndent(sb, indentLevel + 1);
				sb.append("\n");
			}
		}
		makeIndent(sb, indentLevel);
		sb.append("を繰り返す\n");
		return pNext.getLeft().appendTo(sb, indentLevel);
	}

	@Override
	public boolean editMe()
	{
		EditDialog dialog = new EditDialog();
		dialog.setVisible(true);
		return isDirty();
	}

	private class EditDialog extends MyDialog
	{
		private static final long serialVersionUID = 1L;
		JButton btnOK, btnCancel;
		JTextField text1, text2, text3, text4;

		public EditDialog() {
			super();
			this.setTitle("繰り返しの編集");
			JPanel panel = new JPanel();
			panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
			text1 = new JTextField(40);
			text1.setFont(tfont);
			grabFocus(text1);
			text1.setText(var);
			text2 = new JTextField(40);
			text2.setFont(tfont);
			grabFocus(text2);
			text2.setText(start);
			text3 = new JTextField(40);
			text3.setFont(tfont);
			grabFocus(text3);
			text3.setText(end);
			text4 = new JTextField(40);
			text4.setFont(tfont);
			grabFocus(text4);
			text4.setText(step);
			btnOK = new JButton("OK");
			btnOK.addActionListener(this);
			getRootPane().setDefaultButton(btnOK);
			btnCancel = new JButton("キャンセル");
			btnCancel.addActionListener(this);
			panel.add(new JLabel("変数"));
			panel.add(text1);
			panel.add(new JLabel("〜から"));
			panel.add(text2);
			panel.add(new JLabel("〜まで"));
			panel.add(text3);
			panel.add(new JLabel("〜ずつ減らしながら"));
			panel.add(text4);
			panel.add(btnOK);
			panel.add(btnCancel);
			getContentPane().add(panel);
			pack();
			setLocationRelativeTo(null);
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			if(e.getSource() == btnOK)
			{
				setValue(Converter.Zen2Han(text1.getText()),
						Converter.Zen2Han(text2.getText()),
						Converter.Zen2Han(text3.getText()),
						Converter.Zen2Han(text4.getText()));
				makeDirty();
				dispose();
			}
			else if(e.getSource() == btnCancel)
				dispose();
		}
	}

	@Override
	String getText2() {
		return text2;
	}

	@Override
	void setText2(String s) {
		text2 = new String(s);
	}

	@Override
	Parts makeXML(Document doc, Element parent) {
		Element elem = doc.createElement("loopdec");
		elem.setAttribute("var",var);
		elem.setAttribute("start",start);
		elem.setAttribute("end",end);
		elem.setAttribute("step",step);
		Parts parts_end = left.makeXML(doc, elem).getLeft();
		parent.appendChild(elem);
		if(parts_end.getLeft() != null && !parts_end.getLeft().isRecursiveEnd())
			return parts_end.getLeft().makeXML(doc, parent);
		return this;
	}
}
