package pen_flowchart;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Rectangle2D;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class Parts_Misc extends Parts {
	static final int val_num = 7;
	int index; // command_listの何番目？
	int argc;
	String[] argv;
	int text_width , text_height;
	class Commands
	{
		public String format;
		public String command;
		public String jcommand;
		public int    argc;
		public String[] argv;
		Commands(String format, String command, String jcommand, int argc, String[] argv)
		{
			this.format = format;
			this.command = command;
			this.jcommand = jcommand;
			this.argc = argc;
			this.argv = argv;
		}
		String toString(String[] argv)
		{
			if(format != null)
				return String.format(format, (Object[])argv);
			else if(argc > 0)
				return argv[0];
			else
				return jcommand;
		}
	}
	final Commands[] command_list = {
		new Commands(null, 						"",					"≪各種処理≫",0, null),
		new Commands(null,						"anyCommand",		"任意のコマンド", 1, new String[]{"コマンド"}),
		new Commands("描画領域開く(%1$s,%2$s)",	"gOpenWindow",		"描画領域開く",2,new String[]{"幅","高さ"}),
		new Commands("描画領域閉じる()",			"gCloseWindow",	"描画領域閉じる",0, new String[]{}),
		new Commands("描画領域保存(%1$s,%2$s)",	"gSaveWindow",		"描画領域保存", 2, new String[]{"ファイル名","形式"}),
		new Commands("線色設定(%1$s,%2$s,%3$s)",	"gSetLineColor",	"線色設定",3, new String[]{"赤","緑","青"}),
		new Commands("塗色設定(%1$s,%2$s,%3$s)",	"gSetFillColor",	"塗色設定",3, new String[]{"赤","緑","青"}),
		new Commands("線種設定(%1$s)",				"gSetLineShape",	"線種設定",1, new String[]{"線種"}),
		new Commands("線太さ設定(%1$s)",			"gSetLineWidth",	"線太さ設定", 1, new String[]{"太さ"}),
		new Commands("線矢設定(%1$s)",				"gSetArrowType",	"線矢設定", 1, new String[]{"形状"}),
		new Commands("線方向設定(%1%s)",			"gSetArrowDir",	"線方向設定", 1, new String[]{"方向"}),
		new Commands("点種設定(%1$s)",				"gSetDotShape",	"点種設定", 1, new String[]{"種類"}),
		new Commands("文字色設定(%1$s,%2$s,%3$s)","gSetTextColor",	"文字色設定",3, new String[]{"赤","緑","青"}),		// gSetTextColor
		new Commands("文字種設定(%1$s)",			"gSetFont",		"文字種設定",1, new String[]{"フォント"}),			// gSetFont
		new Commands("文字タイプ設定(%1$s)",		"gSetFontType",	"文字タイプ設定", 1, new String[]{"タイプ"}),		// gSetFontType
		new Commands("文字サイズ設定(%1$s)",		"gSetFontSize",	"文字サイズ設定", 1, new String[]{"サイズ"}),		// gSetFontSize
		new Commands("文字描画(%1$s,%2$s,%3$s)",	"gDrawText",		"文字描画", 3, new String[]{"文字列","x","y"}),	// gDrawText
		new Commands("点描画(%1$s,%2$s)",			"gDrawPoint",		"点描画", 2, new String[]{"x","y"}),				// gDrawPoint
		new Commands("線描画(%1$s,%2$s,%3$s,%4$s)","gDrawLine",		"線描画", 4, new String[]{"x1","y1","x2","y2"}),// gDrawLine
		new Commands("矩形描画(%1$s,%2$s,%3$s,%4$s)","gDrawBox",	"矩形描画", 4, new String[]{"x","y","幅","高さ"}),// gDrawBox
		new Commands("矩形塗描画(%1$s,%2$s,%3$s,%4$s)","gFillBox",	"矩形塗描画", 4, new String[]{"x","y","幅","高さ"}),	// gFillBox
		new Commands("楕円描画(%1$s,%2$s,%3$s,%4$s)","gDrawOval",	"楕円描画", 4, new String[]{"x","y","幅","高さ"}),		// gDrawOval
		new Commands("楕円塗描画(%1$s,%2$s,%3$s,%4$s)","gFillOval",	"楕円塗描画", 4, new String[]{"x","y","幅","高さ"}),	// gFillOval
		new Commands("円描画(%1$s,%2$s,%3$s)",	"gDrawCircle",		"円描画", 3, new String[]{"x","y","半径"}), 			// gDrawCircle
		new Commands("円塗描画(%1$s,%2$s,%3$s)",	"gFillCircle",		"円塗描画", 3, new String[]{"x","y","半径"}), 			// gFillCircle
		new Commands("弧描画(%1$s,%2$s,%3$s,%4$s,%5$s,%6$s,%7$s)","gDrawArc",	"弧描画", 7, new String[]{"x","y","幅","高さ","開始角度","描画角度","閉じ方"}), // gDrawArc
		new Commands("弧塗描画(%1$s,%2$s,%3$s,%4$s,%5$s,%6$s,%7$s)","gFillArc","弧塗描画", 7, new String[]{"x","y","幅","高さ","開始角度","描画角度","閉じ方"}), // gFillArc
		new Commands("gDrawPolygon(%1$s,%2$s,%3$s)","gDrawPolygon",	"gDrawPolygon", 3, new String[]{"x配列","y配列","点の個数"}),	// gDrawPolygon
		new Commands("gFillPolygon(%1$s,%2$s,%3$s)","gFillPolygon",	"gFillPolygon", 3, new String[]{"x配列","y配列","点の個数"}),	// gFillPolygon
		new Commands("gDrawPolyline(%1$s,%2$s,%3$s)","gDrawPolyline",	"gDrawPolyline", 3, new String[]{"x配列","y配列","点の個数"}),	// gDrawPolyline
		new Commands("描画領域全消去()",			"gClearWindow",	"描画領域全消去",0, new String[]{}),
		new Commands("gSetOrigin(%1$s,%2$s)",	"gSetOrigin",		"gSetOrigin",2, new String[]{"x","y"}),
		new Commands("gOpenGraphWindow(%1$s,%2$s,%3$s,%4$s,%5$s,%6$s,%7$s)","gOpenGraphWindow","gOpenGraphWindow",7,new String[]{"幅","高さ","x1","y1","x2","y2","軸表示"}),
		new Commands("gSetMap(%1$s,%2$s,%3$s,%4$s)","gSetMap",	"gSetMap", 4, new String[]{"x1","y1","x2","y2"}),
		new Commands("gDrawImage(%1$s,%2$s,%3$s,%4$s)","gDrawImage", "gDrawImage", 5, new String[]{"ファイル名","x","y","幅","高さ"}),
		new Commands("繰り返しを抜ける",			"break",			"繰り返しを抜ける", 0, new String[]{}),
		new Commands("sleep(%1$s)",				"sleep",			"sleep", 1, new String[]{"ミリ秒"}),
		new Commands("%1$s ← openr(%2$s)",		"openr",			"openr",2, new String[]{"ファイル識別子","ファイル名"}),
		new Commands("%1$s ← openw(%2$s)",		"openw",			"openw",2, new String[]{"ファイル識別子","ファイル名"}),
		new Commands("%1$s ← opena(%2$s)",		"opena",			"opena",2, new String[]{"ファイル識別子","ファイル名"}),
		new Commands("close(%1$s)",				"close",			"close",1,new String[]{"ファイル識別子"}),
		new Commands("%1$s ← getstr(%2$s,%3$s)","getstr",		"getstr",3, new String[]{"文字列変数","ファイル識別子","文字数"}),
		new Commands("%1$s ← getline(%2$s)",	"getline",			"getline",2, new String[]{"文字列変数","ファイル識別子"}),
		new Commands("putstr(%1$s,%2$s)",		"putstr",			"putstr",2, new String[]{"ファイル識別子","文字列"}),
		new Commands("putline(%1$s,%2$s)",		"putline",			"putline",2, new String[]{"ファイル識別子","文字列"}),
		new Commands("%1$s ← isfile(%2$s)",	"isfile",			"isfile",2, new String[]{"文字列変数","ファイル名"}),
		new Commands("rename(%1$s,%2$s)",		"rename",			"rename",2, new String[]{"現ファイル名","新ファイル名"}),
		new Commands("flush(%1$s)",				"flush",			"flush",1, new String[]{"ファイル識別子"}),
		new Commands("remove(%1$s)",			"remove",			"remove",1, new String[]{"ファイル名"}),
	};

	public Parts_Misc()
	{
		super();
		index = 0;
		setValue(0, null);
	}

	public void setValue(int index, String[] argv)
	{
		this.index = index;
		this.argc = command_list[index].argc;
		this.argv = new String[val_num];
		for(int i = 0; i < val_num; i++)
			this.argv[i] = new String(i < argc ? argv[i] : "");
		setText(String.format(command_list[index].toString(argv)));
	}

	public void setValue(String command, String[] argv)
	{
		for(int index = 0; index < command_list.length; index++)
		{
			if(command.equals(command_list[index].command) || command.equals(command_list[index].jcommand))
			{
				setValue(index, argv);
			}
		}

	}


	@Override
	public int getHeight() {
		return text_height + 10;
	}

	@Override
	public int getWidth() {
		return text_width + 20;
	}

	@Override
	public Parts paint(Graphics g, FontMetrics fm, Point p) {
		setX1(p.x - getWidth() / 2);
		setX2(p.x + getWidth() / 2);
		setY1(p.y);
		setY2(p.y + getHeight());
		g.setColor(Color.WHITE);
		g.fillRect(getX1(), getY1(), getWidth(), getHeight());
		g.setColor(Color.BLACK);
		drawString(getText(),g,fm,getX1(),getY1(),getX2(),getY2());
		g.drawRect(getX1(), getY1(), getWidth(), getHeight());
		p.y = getY2();
		if(getLeft() == null || getLeft().isRecursiveEnd())
			return this;
		return getLeft().paint(g, fm, p);
	}

	@Override
	public void setSize(Graphics g, FontMetrics fm) {
		text_width = text_height = 0;
		if(getText() != null)
		{
			Rectangle2D rect = fm.getStringBounds(getText(), g);
			text_width = (int)rect.getWidth();
			text_height = (int)rect.getHeight();
		}
		if(text_width < 30) text_width = 30;
		if(text_height < 10) text_height = 10;
	}
	@Override
	public Parts appendTo(StringBuilder sb, int indentLevel) {
		makeIndent(sb, indentLevel);
		sb.append(getText());
		sb.append("\n");
		if(getLeft() != null) return getLeft().appendTo(sb, indentLevel);
		return this;
	}
	@Override
	public boolean editMe()
	{
		EditDialog dialog = new EditDialog(this);
		dialog.setVisible(true);
		return isDirty();
	}

	private class EditDialog extends MyDialog
	{
		private static final long serialVersionUID = 1L;
		JButton btnOK, btnCancel;
		JComboBox cbCommands;
		JPanel subpanel;
		JLabel[] label;
		JTextField[] text;
		int argc;

		public EditDialog(Parts_Misc p) {
			super();
//			parts = p;
			this.setTitle("各種処理の編集");
			JPanel panel = new JPanel();
			panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
			subpanel = new JPanel();
			cbCommands = new JComboBox();
			for(int i = 0; i < command_list.length; i++)
			{
				cbCommands.addItem(command_list[i].jcommand);
				if(index == i)
				{
					cbCommands.setSelectedIndex(i);
					argc = command_list[i].argc;
				}
			}
			cbCommands.addActionListener(new ActionListener(){

				@Override
				public void actionPerformed(ActionEvent arg0) {
					int i = cbCommands.getSelectedIndex();
					if(i >= 0)	argc = command_list[i].argc;
					layoutComponents();
				}});
			text = new JTextField[val_num];
			label = new JLabel[val_num];
			for(int i = 0; i < val_num; i++)
			{
				text[i] = new JTextField(30);
				text[i].setFont(tfont);
				label[i] = new JLabel();
				grabFocus(text[i]);
				text[i].setText(p.argv[i]);
			}
			panel.add(subpanel);
			btnOK = new JButton("OK");
			btnOK.addActionListener(this);
			getRootPane().setDefaultButton(btnOK);
			btnCancel = new JButton("キャンセル");
			btnCancel.addActionListener(this);

			panel.add(btnOK);
			panel.add(btnCancel);
			getContentPane().add(panel);
			layoutComponents();
			setLocationRelativeTo(null);
		}

		private void layoutComponents()
		{
			GridBagLayout layout = new GridBagLayout();
			GridBagConstraints c = new GridBagConstraints();
			subpanel.removeAll();
			subpanel.setLayout(layout);
			c.gridwidth = 1;
			JLabel label = new JLabel("命令");
			layout.setConstraints(label, c);
			subpanel.add(label);
			c.gridwidth = GridBagConstraints.REMAINDER;
			layout.setConstraints(cbCommands, c);
			subpanel.add(cbCommands);
			int idx = cbCommands.getSelectedIndex();
			for(int i = 0; i < argc; i++)
			{
				c.gridwidth = 1;
				label = new JLabel(command_list[idx].argv[i]);
				layout.setConstraints(label, c);
				subpanel.add(label);
				c.gridwidth = GridBagConstraints.REMAINDER;
				layout.setConstraints(text[i], c);
				subpanel.add(text[i]);
			}
			pack();
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			if(e.getSource() == btnOK)
			{
				String[] argv = new String[argc];
				for(int i = 0; i < argc; i++) argv[i] = Converter.Zen2Han(text[i].getText());
				setValue(cbCommands.getSelectedIndex(), argv);
				makeDirty();
				dispose();
			}
			else if(e.getSource() == btnCancel)
				dispose();
		}
	}

	@Override
	Parts makeXML(Document doc, Element parent) {
		Element elem = doc.createElement("misc");
		elem.setAttribute("command", command_list[index].command);
		elem.setAttribute("argc", Integer.toString(command_list[index].argc));
		for(int i = 0; i < argc; i++)
		{
			elem.setAttribute("argv" + Integer.toString(i + 1), argv[i]);
		}
		parent.appendChild(elem);
		if(left != null && !left.isRecursiveEnd()) return left.makeXML(doc, parent);
		return this;
	}
}
