package pen_flowchart;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.geom.Rectangle2D;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.text.BadLocationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

//import com.itextpdf.text.pdf.PdfContentByte;

public class Parts_Output extends Parts {
	int text_width, text_height;
	boolean nocr_flag;
	String val;

	public Parts_Output()
	{
		super();
		nocr_flag = false;
		setValue("≪値≫", false);
	}

	public void setValue(String s, boolean nocr)
	{
		val = new String(s);
		nocr_flag = nocr;
//		setText(s + "を表示");
		setText(s);
	}

	@Override
	public int getHeight() {
		return text_height + size * 2;
	}

	@Override
	public int getWidth() {
		return text_width + size * 6;
	}

	@Override
	public Parts paint(Graphics g, FontMetrics fm, Point p) {
		setX1(p.x - getWidth() / 2);
		setX2(p.x + getWidth() / 2);
		setY1(p.y);
		setY2(p.y + getHeight());
		int x[] = {getX2() - size * 2, getX1() + size * 2, getX1(), getX1() + size * 2, getX2() - size * 2};
		int y[] = {getY1(), getY1(), (getY1() + getY2()) /2, getY2(), getY2()};
		g.setColor(Color.WHITE);
		g.fillPolygon(x, y, 5);
		g.fillArc(getX2() - size * 4, getY1(), size * 4, getY2() - getY1(), -90, 180);
		g.setColor(Color.BLACK);
		drawString(getText(),g,fm,getX1(),getY1(),getX2(),getY2());
		g.drawPolyline(x, y, 5);
		g.drawArc(getX2() - size * 4, getY1(), size * 4, getY2() - getY1(), -90, 180);
		if(nocr_flag)
		{
			int x1 = getX2() - size * 2;
			int y1 = (getY1() + getY2())/2;
			g.drawLine(x1 + size, y1 - size - 1, x1 + size, y1 + size + 1);
			g.drawLine(x1 + size, y1 + size + 1, x1    , y1 + size + 1);
			g.drawLine(x1    , y1 + size + 1, x1 + 2, y1 + size + 1 + 2);
			g.drawLine(x1    , y1 + size + 1, x1 + 2, y1 + size + 1 - 2);
			g.drawLine(x1 + size + 3, y1 + size - 2 - 2, x1 + size - 3, y1 - size + 2 - 2);
			g.drawLine(x1 + size - 3, y1 + size - 2 - 2, x1 + size + 3, y1 - size + 2 - 2);
		}
		p.y = getY2();
		if(getLeft() == null || getLeft().isRecursiveEnd())
			return this;
		return getLeft().paint(g, fm, p);
	}
/*
	@Override
	public Parts paintPdf(PdfContentByte cb, int height, Graphics g,
			FontMetrics fm, Point p) {
		setX1(p.x - getWidth() / 2);
		setX2(p.x + getWidth() / 2);
		setY1(p.y);
		setY2(p.y + getHeight());
		int x[] = {getX2() - 10, getX1() + 10, getX1(), getX1() + 10, getX2() - 10};
		int y[] = {getY1(), getY1(), (getY1() + getY2()) /2, getY2(), getY2()};
		g.setColor(Color.WHITE);
		g.fillPolygon(x, y, 5);
		g.fillArc(getX2() - 20, getY1(), 20, getY2() - getY1(), -90, 180);
		g.setColor(Color.BLACK);
		drawStringPdf(cb, height, getText(),g,fm,getX1(),getY1(),getX2(),getY2());
		g.drawPolyline(x, y, 5);
		g.drawArc(getX2() - 20, getY1(), 20, getY2() - getY1(), -90, 180);

		p.y = getY2();
		if(getLeft() == null || getLeft().isRecursiveEnd())
			return this;
		return getLeft().paintPdf(cb, height, g, fm, p);
	}
*/
	@Override
	public void setSize(Graphics g, FontMetrics fm) {
		text_width = text_height = 0;
		if(getText() != null)
		{
			Rectangle2D rect = fm.getStringBounds(getText(), g);
			text_width = (int)rect.getWidth();
			text_height = (int)rect.getHeight();
		}
		if(text_width < size * 6) text_width = size * 6;
		if(text_height < size * 2) text_height = size * 2;
	}

	@Override
	public Parts appendTo(StringBuilder sb, int indentLevel) {
		makeIndent(sb, indentLevel);
		sb.append(val + " を" + (nocr_flag ? "改行なしで" : "") +"表示する\n");
		if(getLeft() != null) return getLeft().appendTo(sb, indentLevel);
		return this;
	}

	@Override
	public boolean editMe()
	{
		EditDialog dialog = new EditDialog();
		dialog.setVisible(true);
		return isDirty();
	}

	private class EditDialog extends MyDialog
	{
		private static final long serialVersionUID = 1L;
		JButton btnOK, btnCancel;
		JCheckBox cbCr;
		JButton btnQuote;
		JTextField text;

		public EditDialog() {
			super();
			this.setTitle("出力の編集");
			JPanel panel = new JPanel();
			panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
			text = new JTextField(40);
			text.setFont(tfont);
			grabFocus(text);
			text.setText(val);
			cbCr = new JCheckBox("改行なし", nocr_flag);
			btnQuote = new JButton("「」挿入");
			btnQuote.addActionListener(this);
			btnOK = new JButton("OK");
			btnOK.addActionListener(this);
			getRootPane().setDefaultButton(btnOK);
			btnCancel = new JButton("キャンセル");
			btnCancel.addActionListener(this);
			panel.add(new JLabel("出力する値"));
			panel.add(text);
//			JPanel panel1 = new JPanel();
//			panel1.add(cbCr);
//			panel1.add(btnQuote);
			panel.add(cbCr);
			panel.add(btnQuote);
//			panel.add(panel1);
			panel.add(btnOK);
			panel.add(btnCancel);
			getContentPane().add(panel);
			pack();
			setLocationRelativeTo(null);
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			if(e.getSource() == btnOK)
			{
				setValue(Converter.Zen2Han(text.getText()), cbCr.isSelected());
				makeDirty();
				dispose();
			}
			else if(e.getSource() == btnCancel)
				dispose();
			else if(e.getSource() == btnQuote)
			{
				int pos1 = text.getSelectionStart();
				int pos2 = text.getSelectionEnd();
				if(pos1 < pos2)
				{
					text.replaceSelection("「"+text.getSelectedText()+"」");
				}
				else
				{
					int pos = text.getCaretPosition();
					javax.swing.text.Document doc = text.getDocument();
					try {
						doc.insertString(pos, "「」", null);
						text.setDocument(doc);
//						text.setCaretPosition(pos + 1);
					} catch (BadLocationException e1) {
						e1.printStackTrace();
					}
				}
			}
		}
	}

	@Override
	Parts makeXML(Document doc, Element parent) {
		Element elem = doc.createElement("output");
		elem.setAttribute("val", val);
		if(nocr_flag) elem.setAttribute("nocr", "true");
		parent.appendChild(elem);
		if(left != null && !left.isRecursiveEnd()) return left.makeXML(doc, parent);
		return this;
	}
}
